\sections{Flags}

\section{CPSR}

The \texttt{cpsr} or \textsc{Current Program Status Register} is a 32-bit register that is divided into four fields,
8 bits wide each : \emph{flags, status, extension, and control}.

\subsubsection{Co-processors}

These instructions extend the processor's instruction set. They are quite old-- obsolete even-- and were mostly used for
specific computations. They are not part of this course's ARM chip.

\begin{instruction}[LDR]
    Load a single value from a virtual address in memory.
    This instruction has many addressing modes as well as datatypes.
    \marginnote{When the datatype is a word, the memory address must be divisible by four.}
    .align is an assembly directive that provides necessary padding for such situations. For instance, .align 2 will make an
    address divisible by 4.
\end{instruction}

\begin{remark}
    STATIC variables in OOP languages are simply variables whose address is defined at compile time and remains unchanging until
    the program ends.
\end{remark}

\section{Address Space}

\section{Cache}

\section{Compilation}

\marginnote{printf in C: functions with more than 4 arguments will not have all of them stored at compile time. the first four
will be stored in the r0-r3 and the rest will be put on the memory stack. This is done using the principle of pass by value.
Look closely at primitive datatypes and built-in functions in C to translate them effectively in another language (here in assembly).}

\section{Interrupts}

